module Synapse
  module Rails
    class Engine < ::Rails::Engine
      isolate_namespace ::Synapse::Rails
      config.before_configuration do |app|
        Tenancy.application = app.class.parent_name.underscore
        Rails.use :postgresql, :PG
        Rails.use :mysql, :Mysql2
        Rails.use :memcached, :Dalli
        Rails.use :redis, :Redis
        Rails.use :smtp, :ActionMailer
        Rails.use :zookeeper, :ZK, check: false
        Rails.start
      end
      config.after_initialize do |app|
        Logger.rebind ::Rails.logger
      end
    end
  end
end