module Synapse
  module Rails
    class ProviderProxy
      attr_accessor :mode, :uri, :check, :inter, :rise, :fall
      def initialize params={}
        @mode    = ( params[:mode]  || "tcp" )
        @check   =   params[:check] == nil ? true : params[:check]
        @uri     =   params[:uri]
        @inter   = ( params[:inter] || "2s" )
        @rise    = ( params[:rise]  || 2 )
        @fall    = ( params[:fall]  || 3 )
      end
      def haproxy
        {
          port: Freeport.port,
          listen: listen,
          server_options: server_options
        }.with_indifferent_access
      end
      def server_options
        return "check inter #{inter} rise #{rise} fall #{fall}" if check
        ""
      end
      def listen
        @listen = []
        @listen << "mode #{mode}"
        @listen << "option httpchk #{uri}" if uri
        @listen
      end
    end
  end
end